<html>
<head>
<title>OgreSkeletonInstance.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreSkeletonInstance.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreSkeletonInstance_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __SkeletonInstance_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __SkeletonInstance_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreSkeleton_8h.html">OgreSkeleton.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>Ogre {
<a name="l00036"></a>00036 
<a name="l00052"></a><a class="code" href="classOgre_1_1SkeletonInstance.html">00052</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1SkeletonInstance.html" title="A SkeletonInstance is a single instance of a Skeleton used by a world object.">SkeletonInstance</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>
<a name="l00053"></a>00053     {
<a name="l00054"></a>00054     <span class="keyword">public</span>:
<a name="l00058"></a>00058         <a class="code" href="classOgre_1_1SkeletonInstance.html" title="A SkeletonInstance is a single instance of a Skeleton used by a world object.">SkeletonInstance</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SkeletonPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to SkeletonPtr.">SkeletonPtr</a>&amp; masterCopy);
<a name="l00059"></a>00059         ~<a class="code" href="classOgre_1_1SkeletonInstance.html" title="A SkeletonInstance is a single instance of a Skeleton used by a world object.">SkeletonInstance</a>();
<a name="l00060"></a>00060 
<a name="l00062"></a>00062         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> getNumAnimations(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00063"></a>00063 
<a name="l00065"></a>00065         <a class="code" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a>* getAnimation(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index) <span class="keyword">const</span>;
<a name="l00067"></a>00067         <a class="code" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a>* _getAnimationImpl(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, 
<a name="l00068"></a>00068             <span class="keyword">const</span> <a class="code" href="structOgre_1_1LinkedSkeletonAnimationSource.html" title="Link to another skeleton to share animations.">LinkedSkeletonAnimationSource</a>** linker = 0) <span class="keyword">const</span>;
<a name="l00069"></a>00069 
<a name="l00076"></a>00076         <a class="code" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a>* createAnimation(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> length);
<a name="l00077"></a>00077 
<a name="l00079"></a>00079         <a class="code" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a>* getAnimation(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, 
<a name="l00080"></a>00080             <span class="keyword">const</span> <a class="code" href="structOgre_1_1LinkedSkeletonAnimationSource.html" title="Link to another skeleton to share animations.">LinkedSkeletonAnimationSource</a>** linker = 0) <span class="keyword">const</span>;
<a name="l00081"></a>00081 
<a name="l00086"></a>00086         <span class="keywordtype">void</span> removeAnimation(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00087"></a>00087 
<a name="l00088"></a>00088 
<a name="l00090"></a>00090         <a class="code" href="classOgre_1_1TagPoint.html" title="A tagged point on a skeleton, which can be used to attach entities to on specific other entities...">TagPoint</a>* createTagPointOnBone(<a class="code" href="classOgre_1_1Bone.html" title="A bone in a skeleton.">Bone</a>* bone, 
<a name="l00091"></a>00091             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> &amp;offsetOrientation = <a class="code" href="classOgre_1_1Quaternion.html#a441b8d52549e1dedec27420325a313ef">Quaternion::IDENTITY</a>, 
<a name="l00092"></a>00092             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> &amp;offsetPosition = <a class="code" href="classOgre_1_1Vector3.html#a5da94afc089ec07612b4a2615bb6b86f">Vector3::ZERO</a>);
<a name="l00093"></a>00093 
<a name="l00095"></a>00095         <span class="keywordtype">void</span> freeTagPoint(<a class="code" href="classOgre_1_1TagPoint.html" title="A tagged point on a skeleton, which can be used to attach entities to on specific other entities...">TagPoint</a>* tagPoint);
<a name="l00096"></a>00096 
<a name="l00098"></a>00098         <span class="keywordtype">void</span> addLinkedSkeletonAnimationSource(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; skelName, 
<a name="l00099"></a>00099             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> scale = 1.0f);
<a name="l00101"></a>00101         <span class="keywordtype">void</span> removeAllLinkedSkeletonAnimationSources(<span class="keywordtype">void</span>);
<a name="l00103"></a>00103         <a class="code" href="classOgre_1_1ConstVectorIterator.html" title="Concrete IteratorWrapper for const access to the underlying container.">LinkedSkeletonAnimSourceIterator</a> 
<a name="l00104"></a>00104             getLinkedSkeletonAnimationSourceIterator(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00105"></a>00105 
<a name="l00107"></a>00107         <span class="keywordtype">void</span> _initAnimationState(<a class="code" href="classOgre_1_1AnimationStateSet.html" title="Class encapsulating a set of AnimationState objects.">AnimationStateSet</a>* animSet);
<a name="l00108"></a>00108 
<a name="l00110"></a>00110         <span class="keywordtype">void</span> _refreshAnimationState(<a class="code" href="classOgre_1_1AnimationStateSet.html" title="Class encapsulating a set of AnimationState objects.">AnimationStateSet</a>* animSet);
<a name="l00111"></a>00111 
<a name="l00113"></a>00113         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getName(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00115"></a>00115         <a class="code" href="namespaceOgre.html#aeb9f62c8e6c4239315286c63321722b2">ResourceHandle</a> getHandle(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00117"></a>00117         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getGroup(<span class="keywordtype">void</span>);
<a name="l00118"></a>00118 
<a name="l00119"></a>00119     <span class="keyword">protected</span>:
<a name="l00121"></a><a class="code" href="classOgre_1_1SkeletonInstance.html#a48f36b22ae7ff40e31458c15ab238a03">00121</a>         <a class="code" href="classOgre_1_1SkeletonPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to SkeletonPtr.">SkeletonPtr</a> <a class="code" href="classOgre_1_1SkeletonInstance.html#a48f36b22ae7ff40e31458c15ab238a03" title="Pointer back to master Skeleton.">mSkeleton</a>;
<a name="l00122"></a>00122 
<a name="l00123"></a><a class="code" href="classOgre_1_1SkeletonInstance.html#ac5bce34ee7f106703a20bc83553b219a">00123</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1list.html">list&lt;TagPoint*&gt;::type</a> <a class="code" href="classOgre_1_1SkeletonInstance.html#ac5bce34ee7f106703a20bc83553b219a">TagPointList</a>;
<a name="l00124"></a>00124 
<a name="l00133"></a><a class="code" href="classOgre_1_1SkeletonInstance.html#a9eb0e828ad76dac4111687b772de6df1">00133</a>         <a class="code" href="classOgre_1_1SkeletonInstance.html#ac5bce34ee7f106703a20bc83553b219a">TagPointList</a> <a class="code" href="classOgre_1_1SkeletonInstance.html#a9eb0e828ad76dac4111687b772de6df1" title="Active tag point list.">mActiveTagPoints</a>;
<a name="l00134"></a>00134 
<a name="l00142"></a><a class="code" href="classOgre_1_1SkeletonInstance.html#acc4b5ecb34152eff6a28efa880ae00c1">00142</a>         <a class="code" href="classOgre_1_1SkeletonInstance.html#ac5bce34ee7f106703a20bc83553b219a">TagPointList</a> <a class="code" href="classOgre_1_1SkeletonInstance.html#acc4b5ecb34152eff6a28efa880ae00c1" title="Free tag point list.">mFreeTagPoints</a>;
<a name="l00143"></a>00143 
<a name="l00145"></a><a class="code" href="classOgre_1_1SkeletonInstance.html#a1ffe53c03eae391881bf2ba68110031f">00145</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <a class="code" href="classOgre_1_1SkeletonInstance.html#a1ffe53c03eae391881bf2ba68110031f" title="TagPoint automatic handles.">mNextTagPointAutoHandle</a>;
<a name="l00146"></a>00146 
<a name="l00147"></a>00147         <span class="keywordtype">void</span> cloneBoneAndChildren(<a class="code" href="classOgre_1_1Bone.html" title="A bone in a skeleton.">Bone</a>* source, <a class="code" href="classOgre_1_1Bone.html" title="A bone in a skeleton.">Bone</a>* parent);
<a name="l00150"></a>00150         <span class="keywordtype">void</span> loadImpl(<span class="keywordtype">void</span>);
<a name="l00153"></a>00153         <span class="keywordtype">void</span> unloadImpl(<span class="keywordtype">void</span>);
<a name="l00154"></a>00154 
<a name="l00155"></a>00155     };
<a name="l00159"></a>00159 }
<a name="l00160"></a>00160 
<a name="l00161"></a>00161 
<a name="l00162"></a>00162 <span class="preprocessor">#endif</span>
<a name="l00163"></a>00163 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:52
</p>
</body>
</html>
